<%- include('../partials/header') %>
<%- include('../partials/scripts') %>
<%- include('../partials/select2') %>
</head>

<body class="min-vh-100 d-flex flex-column">
	<%- include('../partials/navbar') %>
	<div class="main-content d-flex flex-column flex-grow-1">
		<%- include('../partials/topbar') %>
		<%- include('./header', { active: 'edit' }) %>
		<!-- Page content -->
		<div class="container-fluid mt--7 flex-grow-1">
			<div class="row">
				<div class="col-xl-12">
					<div class="card">
						<div class="card-header">
							<div class="row align-items-center">
								<div class="col-12">
									<h3 class="mb-0">Editace týmu</h3>
								</div>
							</div>
						</div>
						<div class="card-body bg-secondary">
							<form action="./" method="POST" id="edit-team">
								<h6 class="heading text-muted mb-4">Základní údaje</h6>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="name">Název</label>
												<input type="text" id="name" class="form-control" required
													placeholder="Vyplňte prosím toto povinné pole">
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="district">Okres</label>
												<select class="form-control" id="district" required></select>
											</div>
										</div>
										<div class="col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="categories">Kategorie</label>
												<select class="form-control" id="categories" multiple="multiple"
													required></select>
											</div>
										</div>
									</div>
								</div>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col" id="edit-team-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary">Editovat</button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<%- include('../partials/footer') %>
		</div>
	</div>
	<%- include('../partials/scripts-file-end') %>
	<script>
		$(document).ready(() => {
			API.team
				.findById('<%= req.params.id %>')
				.done(function (team) {
					let $nameInput = $('input#name')
					$nameInput.val(team.name)
					let $districtSelect = $('select#district').select2()
					API.district
						.list()
						.done(function (districts) {
							for (let i = 0; i < districts.length; i++) {
								$districtSelect.append(
									$('<option>', { value: districts[i]._id }).text(districts[i].name.full)
								)
							}
						})

					let categoriesIds = []
					for (let i = 0; i < team.categories.length; i++) {
						categoriesIds.push(team.categories[i]._id)
					}

					let $categoriesSelect = $('select#categories').select2()
					API.category
						.list()
						.done(function (categories) {
							for (let i = 0; i < categories.length; i++) {
								let selected = categoriesIds.includes(categories[i]._id)
								$categoriesSelect.append(
									$('<option>', { value: categories[i]._id, selected: selected }).text(categories[i].name)
								)
							}
						})

					$('form#edit-team').submit(function (event) {
						event.preventDefault()
						let $status = $('div#edit-team-status')
						$status
							.empty()
							.append(
								$('<div>', { class: 'alert alert-default alert-dismissible fade show', role: 'alert' }).append(
									$('<span>', { class: 'alert-icon' }).append(
										$('<i>', { class: 'fas fa-circle-notch fa-spin' })
									),
									$('<span>', { class: 'alert-text' }).append(
										// $('<strong>').text('Gratuluji!'),
										'Zpracovávám'
									),
									$('<button>', { type: 'button', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'Close' }).append(
										$('<span>', { 'aria-hidden': 'true' }).html('&times;')
									)
								)
							)
							.show()

						API.team
							.edit('<%= req.params.id %>', $nameInput.val(), $categoriesSelect.val(), $districtSelect.val())
							.done(function (responseFromServer) {
								if (responseFromServer === 'ok') {
									$status
										.empty()
										.append(
											$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
												$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
												$('<strong>').text('Gratuluji!'),
												' Úspěšně jste upravil(a) tým'
											)
										)
										.show()

									// Reload page
									setTimeout(function () {
										window.location.href = window.location.href;
									}, 3500)
								} else {
									$status
										.empty()
										.append(
											$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
												$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
												$('<strong>').text('Ach ne! '),
												responseFromServer
											)
										)
										.show()
								}
							})
					})
				})
		})
	</script>
	<%- include('../partials/file-end') %>